#include "creddy.h"

void keyid_main(options_t *opts) {
    if (opts->cert == NULL)
        usage(opts);

    certificate_t *cert = cert_from_file(opts->cert);
    char *keyid = cert_keyid(cert);
    puts(keyid);

    free(keyid);
    DESTROY_IF(cert);
}

char *cert_keyid(certificate_t *cert) {
    x509_t *x509 = (x509_t *)cert;
    chunk_t id = x509->get_subjectKeyIdentifier(x509);
    chunk_t string = chunk_to_hex(id, NULL, 0);
    return string.ptr;
}
